from typing import Optional, List
from datetime import datetime

from runai import models
from runai.api.runai_api_service import RunaiAPIService, deprecated_message


class ReportsApi(RunaiAPIService):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        self._api_client = api_client

    def create_report(
        self,
        report_request_fields: models.ReportRequestFields,
    ):
        r"""


        ### Description
        Create a new report request.

        ### Parameters:
        ```python
        report_request_fields: ReportRequestFields
        ```
        report_request_fields: Report to create.

        ### Example:
        ```python
        ReportsApi(
            report_request_fields=runai.ReportRequestFields()
        )
        ```
        """

        # Body params:
        body_params = report_request_fields

        resource_path = f"/api/v1/org_unit/reports".replace("_", "-")
        method = "POST"
        return self._api_client.call_api(
            resource_path=resource_path,
            method=method,
            body=body_params,
        )

    def delete_report_by_id(
        self,
        report_id: str,
    ):
        r"""


        ### Description
        Delete report

        ### Parameters:
        ```python
        report_id: str
        ```
        report_id: The report id

        ### Example:
        ```python
        ReportsApi(
            report_id='575c19e8-c7c3-45b0-8290-2f47397a8383'
        )
        ```
        """

        resource_path = f"/api/v1/org_unit/reports/{report_id}".replace("_", "-")
        method = "DELETE"
        return self._api_client.call_api(
            resource_path=resource_path,
            method=method,
        )

    def download_report_by_id(
        self,
        report_id: str,
    ):
        r"""


        ### Description
        Download report

        ### Parameters:
        ```python
        report_id: str
        ```
        report_id: The report id

        ### Example:
        ```python
        ReportsApi(
            report_id='575c19e8-c7c3-45b0-8290-2f47397a8383'
        )
        ```
        """

        resource_path = f"/api/v1/org_unit/reports/{report_id}/file".replace("_", "-")
        method = "GET"
        return self._api_client.call_api(
            resource_path=resource_path,
            method=method,
        )

    def get_report_by_id(
        self,
        report_id: str,
    ):
        r"""


        ### Description
        Get report

        ### Parameters:
        ```python
        report_id: str
        ```
        report_id: The report id

        ### Example:
        ```python
        ReportsApi(
            report_id='575c19e8-c7c3-45b0-8290-2f47397a8383'
        )
        ```
        """

        resource_path = f"/api/v1/org_unit/reports/{report_id}".replace("_", "-")
        method = "GET"
        return self._api_client.call_api(
            resource_path=resource_path,
            method=method,
        )
